Index: /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4537)
@@ -34,4 +34,5 @@
 
 #if (defined(PJ_WIN32) && PJ_WIN32!=0) || \
+    (defined(PJ_WIN64) && PJ_WIN64!=0) || \
     (defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0)
 
@@ -688,5 +689,5 @@
     pj_str_t send_data;
     char data_str[256];
-    unsigned len;
+    pj_size_t len;
     unsigned i;
     cli_telnet_fe *fe = (cli_telnet_fe *)sess->base.fe;
@@ -761,5 +762,5 @@
 {
     unsigned i;
-    unsigned len;
+    pj_size_t len;
     pj_str_t send_data;
     char data[1028];
@@ -993,5 +994,5 @@
 			       pool, &info);    
 
-    len = pj_ansi_strlen((char *)sess->rcmd->rbuf);
+    len = (unsigned)pj_ansi_strlen((char *)sess->rcmd->rbuf);
 
     switch (status) {
@@ -1034,5 +1035,5 @@
 			  info.hint[0].name.slen);
 
-		len += info.hint[0].name.slen;
+		len += (unsigned)info.hint[0].name.slen;
 		sess->rcmd->rbuf[len] = 0;		    
 	    }
@@ -1167,5 +1168,5 @@
 	pj_ansi_strncpy((char*)&sess->rcmd->rbuf, history->ptr, history->slen);
 	sess->rcmd->rbuf[history->slen] = 0;
-	sess->rcmd->len = history->slen;
+	sess->rcmd->len = (unsigned)history->slen;
 	sess->rcmd->cur_pos = sess->rcmd->len;
 	return PJ_TRUE;
@@ -1257,7 +1258,7 @@
             pj_ansi_snprintf((char *)sess->buf + CLI_TELNET_BUF_SIZE,
                              MAX_CUT_MSG_LEN, CUT_MSG);
-            sess->buf_len = CLI_TELNET_BUF_SIZE +
+            sess->buf_len = (unsigned)(CLI_TELNET_BUF_SIZE +
                             pj_ansi_strlen((char *)sess->buf+
-				           CLI_TELNET_BUF_SIZE);
+				            CLI_TELNET_BUF_SIZE));
         } else
             sess->buf_len += clen;
@@ -1295,5 +1296,5 @@
 	while (!pj_scan_is_eof(&scanner)) {	    	    
 	    pj_scan_get_until_ch(&scanner, '\n', &out_str);	    
-	    str_len = scanner.curptr - str_begin;
+	    str_len = (int)(scanner.curptr - str_begin);
 	    if (*scanner.curptr == '\n') {		
 		if ((str_len > 1) && (out_str.ptr[str_len-2] == '\r')) 
@@ -1301,5 +1302,5 @@
 		    continue;
 		} else {		    
-		    int str_pos = str_begin - scanner.begin;
+		    int str_pos = (int)(str_begin - scanner.begin);
 
 		    if (str_len > 0) {
@@ -1317,5 +1318,5 @@
 	    } else {
 		pj_str_t s;
-		int str_pos = str_begin - scanner.begin;
+		int str_pos = (int)(str_begin - scanner.begin);
 
 		pj_strset(&s, &str->ptr[str_pos], str_len);
@@ -1359,5 +1360,5 @@
 
 static void telnet_fe_write_log(pj_cli_front_end *fe, int level,
-		                const char *data, int len)
+		                const char *data, pj_size_t len)
 {
     cli_telnet_fe *tfe = (cli_telnet_fe *)fe;
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/crc32.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/crc32.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/crc32.c	(revision 4537)
@@ -160,5 +160,5 @@
     pj_uint32_t crc = ctx->crc_state ^ CRC32_NEGL;
 
-    for( ; (((unsigned long)data) & 0x03) && nbytes > 0; --nbytes) {
+    for( ; (((unsigned long)(pj_ssize_t)data) & 0x03) && nbytes > 0; --nbytes) {
 	crc = crc_tab[CRC32_INDEX(crc) ^ *data++] ^ CRC32_SHIFTED(crc);
     }
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c	(revision 4537)
@@ -62,5 +62,5 @@
     pj_uint8_t *query, *p = (pj_uint8_t*)packet;
     const char *startlabel, *endlabel, *endname;
-    unsigned d;
+    pj_size_t d;
 
     /* Sanity check */
@@ -107,5 +107,5 @@
 
     /* Done, calculate length */
-    *size = p - (pj_uint8_t*)packet;
+    *size = (unsigned)(p - (pj_uint8_t*)packet);
 
     return 0;
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/dns_server.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/dns_server.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/dns_server.c	(revision 4537)
@@ -232,5 +232,5 @@
     } else {
 	if (tab->count < MAX_LABEL) {
-	    tab->a[tab->count].pos = (p-pkt);
+	    tab->a[tab->count].pos = (unsigned)(p-pkt);
 	    tab->a[tab->count].label.ptr = (char*)(p+1);
 	    tab->a[tab->count].label.slen = name->slen;
@@ -257,5 +257,5 @@
 	pj_memcpy(p+1, label.ptr, label.slen);
 
-	size -= (label.slen+1);
+	size -= (int)(label.slen+1);
 	p += (label.slen+1);
 
@@ -270,5 +270,5 @@
     *p++ = '\0';
 
-    return p-pos;
+    return (int)(p-pos);
 }
 
@@ -353,5 +353,5 @@
     }
 
-    return p-pos;
+    return (int)(p-pos);
 }
 
@@ -433,5 +433,5 @@
     }
 
-    return p - pkt;
+    return (int)(p - pkt);
 }
 
@@ -458,5 +458,5 @@
     pool = pj_pool_create(srv->pf, "dnssrvrx", 512, 256, NULL);
 
-    status = pj_dns_parse_packet(pool, data, size, &req);
+    status = pj_dns_parse_packet(pool, data, (unsigned)size, &req);
     if (status != PJ_SUCCESS) {
 	char addrinfo[PJ_INET6_ADDRSTRLEN+10];
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 4537)
@@ -230,5 +230,5 @@
 
     if (sent <= 0) {
-        hreq->error = (sent < 0 ? -sent : PJLIB_UTIL_EHTTPLOST);
+        hreq->error = (sent < 0 ? (pj_status_t)-sent : PJLIB_UTIL_EHTTPLOST);
         pj_http_req_cancel(hreq, PJ_TRUE);
         return PJ_FALSE;
@@ -774,5 +774,5 @@
  * present, NULL will be returned.
  */
-static char *get_url_at_pos(const char *str, long len)
+static char *get_url_at_pos(const char *str, pj_size_t len)
 {
     const char *end = str + len;
@@ -802,5 +802,5 @@
 {
     pj_scanner scanner;
-    int len = url->slen;
+    pj_size_t len = url->slen;
     PJ_USE_EXCEPTION;
 
@@ -974,5 +974,5 @@
 	pj_assert(user_pos != 0 && user_pos < at_pos);
 	user_pos += 2;
-	removed_len = at_pos + 1 - user_pos;
+	removed_len = (int)(at_pos + 1 - user_pos);
 	pj_memmove(user_pos, at_pos+1, hreq->url.ptr+hreq->url.slen-at_pos-1);
 	hreq->url.slen -= removed_len;
@@ -1160,10 +1160,10 @@
 	phdr->name = pj_str("Proxy-Authorization");
 
-    len = PJ_BASE256_TO_BASE64_LEN(user_pass.slen) + 10;
+    len = (int)(PJ_BASE256_TO_BASE64_LEN(user_pass.slen) + 10);
     phdr->value.ptr = (char*)pj_pool_alloc(hreq->pool, len);
     phdr->value.slen = 0;
 
     pj_strcpy2(&phdr->value, "Basic ");
-    len -= phdr->value.slen;
+    len -= (int)phdr->value.slen;
     pj_base64_encode((pj_uint8_t*)user_pass.ptr, (int)user_pass.slen,
 		     phdr->value.ptr + phdr->value.slen, &len);
@@ -1176,5 +1176,6 @@
 #define MD5_STRLEN 32
 /* A macro just to get rid of type mismatch between char and unsigned char */
-#define MD5_APPEND(pms,buf,len)	pj_md5_update(pms, (const pj_uint8_t*)buf, len)
+#define MD5_APPEND(pms,buf,len)	pj_md5_update(pms, (const pj_uint8_t*)buf, \
+		   (unsigned)len)
 
 /* Transform digest to string.
@@ -1338,5 +1339,5 @@
 
     /* Allocate space for the header */
-    len = 8 + /* Digest */
+    len = (int)(8 + /* Digest */
 	  16 + hreq->param.auth_cred.username.slen + /* username= */
 	  12 + chal->realm.slen + /* realm= */
@@ -1349,5 +1350,5 @@
 	  30 + /* cnonce= */
 	  12 + chal->opaque.slen + /* opaque=".." */
-	  0;
+	  0);
     phdr->value.ptr = (char*)pj_pool_alloc(hreq->pool, len);
 
@@ -1538,6 +1539,6 @@
             /* Header field "Content-Length" */
             pj_utoa(hreq->param.reqdata.total_size ? 
-                    hreq->param.reqdata.total_size: 
-                    hreq->param.reqdata.size, buf);
+                    (unsigned long)hreq->param.reqdata.total_size: 
+                    (unsigned long)hreq->param.reqdata.size, buf);
             str_snprintf(&pkt, BUF_SIZE, PJ_TRUE, "%s: %s\r\n",
                          CONTENT_LENGTH, buf);
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/pcap.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/pcap.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/pcap.c	(revision 4537)
@@ -229,5 +229,5 @@
 	unsigned rec_incl;
 	pj_ssize_t sz;
-	unsigned sz_read = 0;
+	pj_size_t sz_read = 0;
 	pj_status_t status;
 
@@ -236,5 +236,5 @@
 	/* Read PCAP packet header */
 	sz = sizeof(tmp.rec);
-	status = read_file(file, &tmp.rec, &sz);
+	status = read_file(file, &tmp.rec, &sz); 
 	if (status != PJ_SUCCESS) {
 	    TRACE_((file->obj_name, "read_file() error: %d", status));
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/resolver.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/resolver.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/resolver.c	(revision 4537)
@@ -673,5 +673,6 @@
 static void init_res_key(struct res_key *key, int type, const pj_str_t *name)
 {
-    unsigned i, len;
+    unsigned i;
+    pj_size_t len;
     char *dst = key->name;
     const char *src = name->ptr;
@@ -884,6 +885,6 @@
     enum { MAX_SEARCH = 20 };
     pj_str_t hostname, alias = {NULL, 0}, *resname;
-    unsigned bufstart = 0;
-    unsigned bufleft = sizeof(rec->buf_);
+    pj_size_t bufstart = 0;
+    pj_size_t bufleft = sizeof(rec->buf_);
     unsigned i, ansidx, search_cnt=0;
 
@@ -1347,5 +1348,5 @@
 	char errmsg[PJ_ERR_MSG_SIZE];
 
-	status = -bytes_read;
+	status = (pj_status_t)-bytes_read;
 	pj_strerror(status, errmsg, sizeof(errmsg));
 	PJ_LOG(4,(resolver->name.ptr, 
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/scanner.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/scanner.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/scanner.c	(revision 4537)
@@ -112,6 +112,7 @@
 }
 
-PJ_DEF(void) pj_scan_init( pj_scanner *scanner, char *bufstart, int buflen, 
-			   unsigned options, pj_syn_err_func_ptr callback )
+PJ_DEF(void) pj_scan_init( pj_scanner *scanner, char *bufstart, 
+			   pj_size_t buflen, unsigned options, 
+			   pj_syn_err_func_ptr callback )
 {
     PJ_CHECK_STACK();
@@ -550,5 +551,5 @@
 {
     register char *s = scanner->curptr;
-    int speclen;
+    pj_size_t speclen;
 
     if (s >= scanner->end) {
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/sha1.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/sha1.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/sha1.c	(revision 4537)
@@ -210,6 +210,7 @@
 
     j = (context->count[0] >> 3) & 63;
-    if ((context->count[0] += len << 3) < (len << 3)) context->count[1]++;
-    context->count[1] += (len >> 29);
+    if ((context->count[0] += (pj_uint32_t)len << 3) < (len << 3)) 
+	context->count[1]++;
+    context->count[1] += ((pj_uint32_t)len >> 29);
     if ((j + len) > 63) {
         pj_memcpy(&context->buffer[j], data, (i = 64-j));
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/srv_resolver.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/srv_resolver.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/srv_resolver.c	(revision 4537)
@@ -103,5 +103,5 @@
 					pj_dns_srv_async_query **p_query)
 {
-    int len;
+    pj_size_t len;
     pj_str_t target_name;
     pj_dns_srv_async_query *query_job;
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/xml.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/xml.c	(revision 4536)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/xml.c	(revision 4537)
@@ -236,5 +236,5 @@
 	*p++ = '/';
 	*p++ = '>';
-	return p-buf;
+	return (int)(p-buf);
     }
 
@@ -288,5 +288,5 @@
 #undef SIZE_LEFT
 
-    return p - buf;
+    return (int)(p-buf);
 }
 
@@ -305,5 +305,5 @@
 	    return -1;
 	pj_memcpy(buf, prolog.ptr, prolog.slen);
-	prolog_len = prolog.slen;
+	prolog_len = (int)prolog.slen;
     }
 
